/* ***************************************************************
**	25/7/12	cnv5io.c	v5.0
** minimal interface
*/

#include "lpc23xx.h"
#include "cnv5io.h"
#include "cnv5.h"


// ---------------------------------------------------------------------------
//	com0 routines
// ---------------------------------------------------------------------------
void puts_u0(char *s)
{
int i;
	i = 0;
	while(1){
		while(1)
			if(U0LSR & 0x20)
				break;
		U0THR = s[i];
		i++;
		if(s[i] == '\0')
			return;
	}
}

void putc_u0(char c)
{
	while(1)
		if(U0LSR & 0x20)
			break;
	U0THR = c;
}

char getc_u0(void)
{
	char c;

	while(1)
		if(hasc_u0())
			break;
	c = U0RBR;
	return(c);
}

char hasc_u0(void)
{
	char hid;
  	hid = U0LSR; 
	if(hid & 0x01)
		return(1);
	if(hid & 0x0e)	// char errors
		hid = U0RBR;	// discard invalid character
	return(0);
}

// ---------------------------------------------------------------------------
//	com 2 routines
// ---------------------------------------------------------------------------
void puts_u2(char *s)
{
int i;
	i = 0;
	while(1){
		while(1)		// wait for permission to send
			if(!CTS2)
				break;
		while(1)
			if(U2LSR & 0x40)	// wait for tx data reg's empty
				break;
		U2THR = s[i];
		i++;
		if(s[i] == '\0')
			return;
	}
}

void putc_u2(char c)
{
	while(1)	// wait for permission to send
		if(!CTS2)
			break;
	while(1)
		if(U2LSR & 0x40)	// wait for tx data reg's empty
			break;
	U2THR = c;
}

char getc_u2(void)
{
	while(1)
		if(hasc_u2())
			break;
	CLR_RTS2;
	return(U2RBR);
}

char hasc_u2(void)
{
	char hid;
  	hid = U2LSR; 
	if(hid & 0x80)	// char errors
		hid = U2RBR;	// discard invalid character
  	hid = U2LSR; 
	if(hid & 0x01)
		return(1);
	else
		return(0);
}

