/* 
** 14/2/11 cnv5 test utility
The unit pcb is set up with a 14.7456 MHz xtal, baud rates set to 115200.  The
interrupt is on uart2, where a receive threshold of 8 bytes was set. A loopback
 was put on uart2 i.e. tx2-rx2, cts2-rts2.  If you enable the interrupts in main,
you will see that only 8 chars are received from uart0, i.e. the interrupts are 
working.  If they are disabled, the data flow on u0 continues.  It is also obvious 
that the uart2 isr in setup.c is never reached.

*/

#include "lpc23xx.h"
#include "cnv5.h"
#include "cnv5io.h"
#include "setup.h"
#include "armvic.h"

char buf[24];

// --------------------------------------------------------------------------
//	main()
// --------------------------------------------------------------------------
int main(void)
{
	int		i;
	char 	c;

	init_devices();

//	enableFIQ();		// I have tried both IRQ and FIQ
//	enableIRQ();

	CLR_RTS2;

	while(1){
		for(i=0;i<16;i++){
			putc_u2('x');
			putc_u0('x');
			if(CTS2){
				c = getc_u2();
				putc_u0('i');
			}
		}
	}		
	return(0);
}


