// v1.0 11/2/2011

#include "lpc23xx.h"
#include "setup.h"
#include "armVIC.h"
#include "cnv5io.h"

void ConfigurePLL(void);
void i2c_init(void);
void mam_init(void);
void port_init(void);
void pwm_init(void);
void spi0_init(void);
void ssp0_init(void);
void timer0_init(void); 
void uart0_init(void);
void uart1_init(void);
void uart2_init(void);
void uart3_init(void);
void watchdog_init(void);

//void IRQ_Routine (void)   __attribute__ ((interrupt("IRQ")));
//void FIQ_Routine (void)   __attribute__ ((interrupt("FIQ")));
//void SWI_Routine (void)   __attribute__ ((interrupt("SWI")));
//void UNDEF_Routine (void) __attribute__ ((interrupt("UNDEF")));
//void watchdog_isr (void) __attribute__ ((interrupt("WDT")));
//void uart0_isr (void) __attribute__ ((interrupt("IRQ")));

//void uart2_isr (void) __attribute__ ((naked));
void uart2_isr (void) __attribute__ ((interrupt("IRQ")));

extern int millisec;
int PLL_MValue, PLL_NValue, CCLKDivValue,USBCLKDivValue;

/*  Stubs for various interrupts (may be replaced later)  */
/*  ----------------------------------------------------  */
/*
void IRQ_Routine (void) {
	ISR_ENTRY();
	U0THR='Q';
 	VICVectAddr = 0; // Acknowledge Interrupt
	ISR_EXIT();
//	while (1) ;	
}

void FIQ_Routine (void)  {
	ISR_ENTRY();
	U0THR='F';	
 	VICVectAddr = 0; // Acknowledge Interrupt
	ISR_EXIT();
//	while (1) ;	
}


void SWI_Routine (void)  {
U0THR='S';	
	while (1) ;	
}


void UNDEF_Routine (void) {
U0THR='U';
	while (1) 
		;	
}
*/
/*
void watchdog_isr(void)
{
	WDMOD |= 0x08;
	VICVectAddr = 0;
}

void uart0_isr(void)
{
 	unsigned char id,in;
 	id=U0IIR; //read interrupt id to clear flag
 	VICVectAddr = 0; // Acknowledge Interrupt
 	id = U0IIR; //read interrupt id to clear flag
	id &= 0x0e;
	if(id == 0x04)
		in = U0RBR;
	else if(id == 0x0c)
		in = U0RBR;
	U0THR = in;
}
*/

void uart2_isr(void)
{
 	unsigned char id;
	ISR_ENTRY();
 	id = U2IIR; //read interrupt id to clear flag
U0THR='I';
	id &= 0x0e;
//	if(id == 0x04)
//	 SET_RTS2;		// stop source from tx
//putc_u0('I');
//	id = U2IIR; //read interrupt id to clear flag
 	VICVectAddr = 0; // Acknowledge Interrupt
	ISR_EXIT();
}

void port_init(void)	
{
	PINSEL0 = 0 |(1<<4)|(1<<6)|(1<<30) ;	// txd0 rxd0 tdx1
	PINSEL1 = 0|1|(1<<2)|(1<<12);			// rxd1 cts1 rts1
	PINSEL2 = 0;
	PINSEL3 = 0|(3<<8)|(3<<10)|(3<<14)|(3<<16);	// sck0 ssel0 miso0 mosi0
	PINSEL4 = 0|1|(2<<18)|(2<<16);		// pwm1.1 txd2 rxd2
	PINSEL5 = 0;
	PINSEL6 = 0; //0x5555;	
	PINSEL7 = 0;
	PINSEL8 = 0;
	PINSEL9 = 0; //(1<<16)|(1<<28)|(2<<18)|(1<<30); 
	PINSEL10 = 0;

	IODIR0 = B10|B11;	//KC1,KC2
	IOCLR0 = B10|B11;	//KC1,KC2

	IOSET1 = B25|B26;				//SPI_CS0,1
	IOCLR1 = B0|B1|B4|B8|B9|B27|B28|B29;
	IODIR1 = B0|B1|B4|B8|B9|B25|B26|B27|B28|B29; //af0-af4 SPI_CS1,0,Tout,KC1,KC2

	FIO2DIR = B7; 			//RTS2
	FIO2SET = B7;
	PINMODE4 = (2<<22)|(2<<24)|(2<<26);		//NO pull up/down keyboard inputs
//FP2xDIR = 0;
	FIO4MASK = 0;
	FIO4SET = B24|B25;
	FIO4DIR = B24|B25;
	PINMODE8 = 0x20;
	EMCControl = 0;
}

void uart0_init(void)
{
	U0IER=0x00;		// no int
	U0FCR=0xc1;		// fifo enable
	U0LCR=0x83;
	U0DLL=0x04;	//Baud rate 115200
	U0DLM=0;
	U0LCR=0x03;
}

void uart1_init(void)
{
 	U1IER=0x00;
 	U1FCR=0xc1;
 	U1MCR=0xC0;	// auto flow control
 	U1LCR=0x83;
 	U1DLL=0x04;	//Baud rate=115200
 	U1DLM=0;
 	U1LCR=0x03;
}
  
void uart2_init(void)
{
	U2IER=0x01;		// recieve int
	U2FCR=0x81;		// fifo enable
	U2LCR=0x83;
	U2DLL=0x04;	//Baud rate 115200
	U2DLM=0;
	U2LCR=0x03;
}

void uart3_init(void)
{
	U3IER=0x00;		// no int
	U3FCR=0xc1;		// fifo enable
	U3LCR=0x83;
	U3DLL=0x04;	//Baud rate 115200
	U3DLM=0;
	U3LCR=0x03;
}

void spi0_init(void)
{
 	S0SPCR=0X00;
 	S0SPCCR=0x00C;
 	S0SPCR=0x20;
 	S0SPINT=0x00;
}

void ssp0_init(void)
{
	PCLKSEL1 = (2<<10);
// 	SSP0CR0=0x07c7;
 	SSP0CR0=0x0707;
 	SSP0CR1=2;
 	SSP0CPSR=60;		// was 4
}

void watchdog_init(void)
{
 	WDTC=0x000000FF;
 	WDMOD=0x00000000;
	WDFEED=0xaa;
	WDFEED=0x55;
}

void mam_init(void)
{
	MAMCR = 0;
	MAMTIM = 3;
	MAMCR = 1;
}


void pwm_init(void)
{					// 6MHz // 6/3 gives 10 mhz
	PWM1TCR=0x2;	//TIMER CONTROL OFF
	PWM1MR0=0x0a;	// max cycle count
	PWM1MR1=0x5;	// pulse duration
	PWM1PR=0;	// prescale
	PWM1MCR=2;	// match control
	PWM1PCR=1<<9;	// enable channel
	PWM1LER=0x6;	// latch enable
	PWM1TCR=0x09;	//TIMER CONTROL enable
}

void timer0_init(void)
{
	T0TCR = 1; 
	T0MCR = 0; 
	T0CCR = 0; 
	T0PR = 0; 
}

void rtc_init(void)
{
 	RTC_CCR = 0;			// stop rtc
// 	RTC_PREINT = 1349;
// 	RTC_PREFRAC = 0x0000;
 	RTC_CCR = 0x11; 		//start rtc
}

void init_devices(void)
{
//	unsigned long* irq;

//	irq = 14
	SCS = 1<<5;			// enable main osc
	while(1){			// wait for it to stabilize
		if(SCS & 1<<6)	// main osc eady
			break;
	}
	PLL_MValue = 11;	// setup for pll, then enable
	PLL_NValue = 0;
	CCLKDivValue = 11;		// 30 MHz
	USBCLKDivValue = 9;		//not correct, but usb not used
	ConfigurePLL();

	mam_init();

	PCONP = 0|B1|B2|B3|B4|B6|B9|B21|B24;		//|B|B|B|B|B
 	port_init();
	PCLKSEL0 = (1<<12);

	VICVectAddr=0;
// 	VICIntSelect = 1<<28;			// uart2 int is fiq
 	VICSoftIntClr = 0xffffffff;
	VICVectAddr28 = (unsigned)(void*)uart2_isr;
	VICVectCntl28 = 1;				
	VICIntEnable = 1<<28;      

	timer0_init(); 
	uart0_init();
	uart1_init();
	uart2_init();
	ssp0_init();
//	spi0_init();
//	rtc_init();
	pwm_init();
}

void ConfigurePLL ( void )
{
	int MValue, NValue;

	if ( PLLSTAT & (1 << 25) )
    {
		PLLCON = 1;			/* Enable PLL, disconnected */
		PLLFEED = 0xaa;
		PLLFEED = 0x55;
    }

    PLLCON = 0;				/* Disable PLL, disconnected */
    PLLFEED = 0xaa;
    PLLFEED = 0x55;
    
	SCS |= 0x20;			/* Enable main OSC */
    while( !(SCS & 0x40) );	/* Wait until main OSC is usable */

    CLKSRCSEL = 0x1;		/* select main OSC, 12MHz, as the PLL clock source */

    PLLCFG = PLL_MValue | (PLL_NValue << 16);
    PLLFEED = 0xaa;
    PLLFEED = 0x55;
      
    PLLCON = 1;				/* Enable PLL, disconnected */
    PLLFEED = 0xaa;
    PLLFEED = 0x55;

    CCLKCFG = CCLKDivValue;	/* Set clock divider */
    while ( ((PLLSTAT & (1 << 26)) == 0) );	/* Check lock bit status */
    
    MValue = PLLSTAT & 0x00007FFF;
    NValue = (PLLSTAT & 0x00FF0000) >> 16;
    while ((MValue != PLL_MValue) && ( NValue != PLL_NValue) );

    PLLCON = 3;				/* enable and connect */
    PLLFEED = 0xaa;
    PLLFEED = 0x55;
	while ( ((PLLSTAT & (1 << 25)) == 0) );	/* Check connect bit status */
	return;
}

